struct Tree {
    typedef int T;
    static constexpr T unit = INT_MIN;
    T f(T a, T b) {return max(a,b);}
    vector<T> s; int n;
    Tree (int n=0, T def = unit):s(2*n,def),n(n) {}
    void update(int pos,T val) {
        for(s[pos+=n]=val;pos/=2;)
            s[pos]=f(s[pos*2],s[pos*2+1]);
    }
    T query(int b, int e) {
        T ra = unit, rb=unit;
        for(b+=n,e+=n;b<e;b/=2,e/=2) {
            if(b%2) ra=f(ra,s[b++]);
            if(e%2) rb=f(s[--e],rb);
        }
        return f(ra,rb);
    }
};